﻿<?php
class MorseClass {
 private static $russian_alphabet = array (
  'А' => '.-',   'Б' => '-...', 'Ц' => '-.-.', 'Д' => '-..', 'Е' => '.',
  'Ф' => '..-.', 'Г' => '--.',  'Х' => '....', 'И' => '..',  'Й' => '.---',
  'К' => '-.-',  'Л' => '.-..', 'М' => '--',   'Н' => '-.',  'О' => '---',
  'П' => '.--.', 'Щ' => '--.-', 'Р' => '.-.',  'С' => '...', 'Т' => '-',
  'У' => '..-',  'Ж' => '...-', 'В' => '.--',  'Ь' => '-..-','Ы' => '-.--',
  'З' => '--..', 'Ч' => '---.', 'Ш'=>'----',   'Ъ'=>'--·--', 'Э' => '..-..', 
  'Ю' => '..--', 'Я' =>'.-.-'
 );
 private static $english_alphabet = array (
  'A' => '.-',   'B' => '-...', 'C' => '-.-.', 'D' => '-..',   'E' => '.',
  'F' => '..-.', 'G' => '--.',  'H' => '....', 'I' => '..',    'J' => '.---',
  'K' => '-.-',  'L' => '.-..', 'M' => '--',   'N' => '-.',    'O' => '---',
  'P' => '.--.', 'Q' => '--.-', 'R' => '.-.',  'S' => '...',   'T' => '-',
  'U' => '..-',  'V' => '...-', 'W' => '.--',  'X' => '-..-',  'Y' => '-.--',
  'Z' => '--..', 'Ö' => '---.', 'Ĥ' => '----', 'Ñ' => '--·--', 'É' => '..-..', 
  'Ü' => '..--', 'Ä' => '.-.-'
 );
 private static $other_chars = array (
  '0' => '-----',  '1' => '.----',  '2' => '..---',  '3' => '...--',  '4' => '....-',  
  '5' => '.....',  '6' => '-....',  '7' => '--...',  '8' => '---..',  '9' => '----.',  
  '.' => '······', ',' => '·-·-·-', ':' => '---···', ';' => '-·-·-·', '(' => '-.--.', 
  "'" => '.----.', '"' => '.-..-.', '-' => '-....-', '/' => '-..-.',  '?' => '..--..', 
  '!' => '--··--', ')' => '-.--.-', '@' => '·--·-·', '&' => '.-...',  '=' => '-...-', 
  '+' => '.-.-.',  '_' => '..--.-', '$' => '...-..-', //'' => '', 
  "{DIV}"=>'-···-', '{ERROR}'=>'........', '{END}'=>'...-.-'
 ); 

 public $error;

 public function text_to_morse ($content, $div='/') {
  $this->content = mb_convert_case($content,MB_CASE_UPPER,'UTF-8');
  $this->error = '';
  $words = preg_split("/[\s]+/msiu", $this->content);
  $outwords = array();
  foreach($words as $word) {
   $bits = array();
   $len = mb_strlen($word,'UTF-8');
   for($i=0; $i<$len; $i++) {
    $char = mb_substr($word,$i,1,'UTF-8');
    $temp = '';
    if (array_key_exists($char,self::$russian_alphabet)) $temp = self::$russian_alphabet[$char];
    else 
     if (array_key_exists($char,self::$english_alphabet)) $temp = self::$english_alphabet[$char];
    else
     if (array_key_exists($char,self::$other_chars)) $temp = self::$other_chars[$char];
    else
     $this->error .= $char;
    if (!empty($temp)) $bits[] = $temp;
   }
   $outwords[] = implode(' ', $bits);
  }
  return implode(' '.$div.' ', $outwords);
 }

 public function morse_to_text ($content, $english = 0) {
  $this->content = $content;
  $this->error = '';
  $bits = preg_split ("/[\s]+/msiu", $this->content);
  $outwords = array();
  foreach($bits as $bit) {
   $item = ($english!=0 ? 
     array_search($bit, self::$english_alphabet) : array_search($bit, self::$russian_alphabet));
   if ($item === false) {
    $item = array_search($bit, self::$other_chars);
    if ($item === false) $this->error .= $bit.' ';
    else $outwords [] = $item;
   }
   else $outwords [] = $item;  
  }
  return implode(' ', $outwords);
 }

}